/*
 * Copyright 2008, Petr Machata
 *
 * This file is part of MicroSweeper.
 *
 * MicroSweeper is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MicroSweeper is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MicroSweeper.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.util.Vector;

public class Debug {
    private static int level = 0;
    private static Vector levels = new Vector();

    public final boolean enabled;

    public Debug(boolean enabled) {
	this.enabled = enabled;
    }

    public synchronized void debug(String str) {
	if (!enabled)
	    return;

	String gap = " ";
	while (gap.length() < level)
	    gap = gap + gap;
	System.out.println(gap.substring(0, level) + str);
    }
    public synchronized void enter(String str) {
	if (!enabled)
	    return;

	debug("<" + str + ">");
	levels.addElement(str);
	level += 1;
    }
    public synchronized void leave() {
	if (!enabled)
	    return;

	level -= 1;
	debug("</" + levels.lastElement() + ">");
	levels.removeElementAt(levels.size() - 1);
    }
}
