/*
 * Copyright 2010, Petr Machata
 *
 * This file is part of MicroSweeper.
 *
 * MicroSweeper is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MicroSweeper is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MicroSweeper.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * This is default implementation of ParticipantSelector that
 * implements howManyMines by dividing given maximum regularly among
 * the available levels.
 */
public abstract class DefaultParticipantSelector
    extends ParticipantSelector
{
    public abstract int maxMines();

    public int howManyMines(int level, int endLevel) {
	if (level >= endLevel)
	    throw new RuntimeException ("level >= endLevel");
	return maxMines() * (level + 1) / endLevel;
    }
}
