/*
 * Copyright 2009, 2011, 2012 Petr Machata
 *
 * This file is part of MicroSweeper.
 *
 * MicroSweeper is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MicroSweeper is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MicroSweeper.  If not, see <http://www.gnu.org/licenses/>.
 */

class Hole
    extends Field
{
    public Hole(MineField mf, byte fieldIdx) {
	super(mf, fieldIdx);
    }

    public Hole(MineField mf, Field copy) {
	super(mf, copy);
    }

    public Field clone(MineField mf) {
	return new Hole(mf, this);
    }

    public Constraint getConstraint() {
	// xxx in fact, we want to emit constraint sum(neighbors)>0,
	// but our CSP doesn't support this.
	return null;
    }

    public String render() {
	return "?";
    }

    public int getColor() {
	return 0;
    }

    public boolean consistent() {
	return true;
    }
}
