/*
 * Copyright 2008,2010,2012 Petr Machata
 *
 * This file is part of MicroSweeper.
 *
 * MicroSweeper is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MicroSweeper is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MicroSweeper.  If not, see <http://www.gnu.org/licenses/>.
 */

public interface MineSweeperDisplay {
    /**
     * This is calle before any drawing is done.  The implementer can
     * place any pre-processing here.
     */
    void beforeDrawing();

    /**
     * This is called for each field that should be drawn.
     *
     * @param f Field to be drawn.
     * @param x, y Coordinates in 1/MineField.getPaintWidthRequest of
     * screen size.
     * @param r Size of the field in 1/MineField.getPaintHeightRequest
     * of screen size.
     */
    void drawField(Field f, int x, int y, int r);

    /**
     * This is calle after the drawing is done.  The implementer can
     * place any post-processing here.
     */
    void afterDrawing();
}
