/* -*-java-*-
 * Copyright 2012 Petr Machata
 *
 * This file is part of MicroSweeper.
 *
 * MicroSweeper is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MicroSweeper is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MicroSweeper.  If not, see <http://www.gnu.org/licenses/>.
 */

public class SpecialField extends EmptyField {
    private final ParticipantSelector parSel;
    private final char code;
    private final int icon;

    public SpecialField(ParticipantSelector parSel, char code,
			MineField mf, byte fieldIdx, int icon) {
	super(mf, fieldIdx);
	this.parSel = parSel;
	this.code = code;
	this.icon = icon;
    }

    public SpecialField(MineField mf, SpecialField copy) {
	super(mf, copy);
	this.parSel = copy.parSel;
	this.code = copy.code;
	this.icon = copy.icon;
    }

    public Field clone(MineField mf) {
	return new SpecialField(mf, this);
    }

    public char constraintCode() {
	return code;
    }

    public ParticipantSelector getParticipantSelector() {
	return parSel;
    }

    public int getIcon() {
	return icon;
    }
}
